//******************************************
//****************Other Stuff***************
//******************************************
//Team Variables
$Game::TeamScores[1] = 0;
$Game::TeamScores[2] = 0;
$Game::TeamScores[3] = 0;
$Game::Teamkings[1] = 0;
$Game::Teamkings[2] = 0;
$Game::Teamkings[3] = 0;
$Game::Teamplayerc[1] = 0;
$Game::Teamplayerc[2] = 0;
$Game::Teamplayerc[3] = 0;
$Game::Teamkills[1] = 0;
$Game::Teamkills[2] = 0;
$Game::Teamkills[3] = 0;
//Team Stuff
$Team1 = new ScriptObject()
{
   teamId = 1;
   name = Red;
   score = 0;
   numPlayers = 0;
   kings = 0;
   color = red;
   nametag = "[Red]";
};

$Team2 = new ScriptObject()
{
   teamId = 2;
   name = Blue;
   score = 0;
   numPlayers = 0;
   kings = 0;
   color = blue;
   nametag = "[Blue]";
};
$Team3 = new ScriptObject()
{
   teamId = 3;
   name = nonplayer;
   score = 0;
   numPlayers = 0;
   kings = 0;
   color = grey;
   nametag = "[NPC]";
};
datablock AudioProfile(Hilloff)
{
   filename    = "~/data/sound/KOTHoff.wav";
   description = "AudioClose3d";
   preload = false;
};
datablock AudioProfile(Hillon) 
{
   filename    = "~/data/sound/KOTH.ogg";
   description = "AudioClose3d";
   preload = false;
	isLooping = true;
description = "AudioCloseLooping3d";
};
//******************************************
//****************Triggers******************
//******************************************
datablock TriggerData(teamkingofthehillTrigger)
{
  tickPeriodMS = 1000; 
  //set to 1000 so it ticks every second
};
function teamkingofthehillTrigger::onEnterTrigger(%this,%trigger,%obj)
{
   %scoreRedTeam = $Game::Teamscores[1];
   %scoreBlueTeam = $Game::Teamscores[2];
   $kingofthehill = %obj.client;
   %client = $kingofthehill;
   $Game::TeamScores[%client.team.teamID]++;
   %client.incScore(1);

//   serverPlay3D(hillon,%obj.getTransform());
$musicHandle = alxPlay(NewSoundStart);  

   $Game::Teamkings[%client.team.teamID]++;
   messageAll('MsgClienthill','\c4 %1 from Team %2 has entered the Hill(Red: %3 | Blue: %4)',%obj.client.name, %obj.client.team.name,%scoreRedTeam,%scoreBlueTeam);
   $KingsoftheHill++;
   %client = $kingofthehill;
   if ($Game::Teamscores[%client.team.teamID] >= $Game::EndGameScore) 
	cycleGame(); 
   }
function teamkingofthehillTrigger::onLeaveTrigger(%this,%trigger,%obj)
{
  %scoreRedTeam = $Game::Teamscores[1];
  %scoreBlueTeam = $Game::Teamscores[2];
  %client = $kingofthehill;
//  serverPlay3D(hilloff,%obj.getTransform()); 
alxStop($musicHandle);

  messageAll('MsgClienthill','\c4 %1 from Team %2 has left the Hill(Red: %3 | Blue: %4)',%obj.client.name, %obj.client.team.name,%scoreRedTeam,%scoreBlueTeam);
  $KingsoftheHill--;
  $Game::Teamkings[%client.team.teamID]--;
}
function teamkingofthehillTrigger::onTickTrigger(%this,%trigger,%obj)
{
 %scoreRedTeam = $Game::Teamscores[1];
 %scoreBlueTeam = $Game::Teamscores[2];
 if ($KingsoftheHill $= 1) { //Makes sure that there is only 1 person on the hill
  %client = $kingofthehill;
  %client.incScore(1);
  $Game::TeamScores[%client.team.teamID]++;
  //gives the person on the hill one point everytime the trigger ticks if there is 
  //only 1 person on the hill
}
 if ($Game::Teamscores[%client.team.teamID] >= $Game::EndGameScore) 
	cycleGame(); 
}

datablock TriggerData(newgameTrigger)
{
	tickPeriodMS = 1000;
};

function newgameTrigger::onEnterTrigger(%this,%trigger,%obj)
{ 
  $kingofthehill = %obj.client;
  %obj.client.setScore(0);
  //resets the score to Start a new game of KOTH
}

function newgameTrigger::onLeaveTrigger(%this,%trigger,%obj)
{
  %client = $kingofthehill;
  %client.setScore(0);
}

function newgameTrigger::onTickTrigger(%this,%trigger,%obj)
{
}

//*********************************
//*******Functions*****************
//*********************************
function serverCmdJoinTeam(%client, %teamid)
{
  %client.joinTeam(%teamid);
}
function MsgAll(%msg)
{
	// useful function for admins to msg everyone
	messageAll('MsgGlobal', 'Admin: %1', %msg);
}

